<?php

/**
 * @file
 *   Configuration page for imagefield zip module.
 */

/**
 * Page generation fucntion for admin/settings/imageinfo-cache
 */
function imagefield_zip_admin_page() {
  $output = '';
  return $output . drupal_get_form('imagefield_zip_admin_form');
}

/**
 * Form builder; Displays imagefield configuration options.
 */
function imagefield_zip_admin_form($form_state) {
  $form = array();

  foreach (content_types() as $node_type => $info) {
    $node_type = check_plain($node_type);
    foreach ($info['fields'] as $field_name => $data) {
      $field_name = check_plain($field_name);
      if ($data['type'] == 'filefield') {
        $form['imagefield_zip_cck_widget_' . $node_type . '_' . $field_name] = array(
          '#type'           => 'radios',
          '#title'          => t('%node - %field: Location of the zip upload field', array(
            '%node' => $info['name'],
            '%field' => $data['field_name'],
          )),
          '#default_value'  => variable_get('imagefield_zip_cck_widget_' . $node_type . '_' . $field_name, IMAGEFIELD_ZIP_CCK_WIDGET),
          '#description'    => t('Link to this widget: <a href="@link">@name</a>', array(
            '@link' => url('admin/content/node-type/' . str_replace('_', '-', $node_type) . '/fields/' . $field_name),
            '@name' => $info['name'] . ' - ' . $data['field_name'],
          )),
          '#options' => array(
            0 => t('Above Imagefield'),
            1 => t('Below Imagefield'),
            2 => t('Disabled'),
          ),
        );
      }
    }
  }

  return system_settings_form($form);
}

/**
 * Called from imagefield_zip_form_alter().
 */
function imagefield_zip_cck_widget_form(&$form, $form_state, $form_id) {
  // Get widget settings.
  $widget_settings = variable_get('imagefield_zip_cck_widget_' . $form['#field']['type_name'] . '_' . $form['#field']['field_name'], IMAGEFIELD_ZIP_CCK_WIDGET);

  // Add in settings form.
  $form['widget']['imagefield_zip'] = array(
    '#type'           => 'fieldset',
    '#title'          => t('Imagefield Zip'),
    '#collapsible'    => 1,
    '#collapsed'      => 1,
    '#weight'         => 20,
  );
  $form['widget']['imagefield_zip']['imagefield_zip_location'] = array(
    '#type'           => 'radios',
    '#title'          => t('Location of the zip upload field'),
    '#default_value'  => $widget_settings,
    '#options' => array(
      0 => t('Above'),
      1 => t('Below'),
      2 => t('Disabled'),
    ),
  );

  // Add in submit handler.
  if (!in_array('imagefield_zip_cck_widget_form_submit', $form['#submit'])) {
    $form['#submit'][] = 'imagefield_zip_cck_widget_form_submit';
  }

}

/**
 * Implements hook_form_submit().
 */
function imagefield_zip_cck_widget_form_submit($form, &$form_state) {
  if (!isset($form_state['values']['imagefield_zip_location'])) {
    return;
  }

  // Save value.
  variable_set('imagefield_zip_cck_widget_' . $form['#field']['type_name'] . '_' . $form['#field']['field_name'], (int) $form_state['values']['imagefield_zip_location']);
  unset($form_state['values']['imagefield_zip_location']);
}
